/*
* @(#)defaultexp.java	1.0 98/12/15
* 
*/

import java.awt.*;
import com.sun.java.swing.*;

/**
* defaultexp encapsulates the default expression building functionality
* for CPE/CDE. This class is inspected with reflection. Application
* specific expression builders may be plugged in as an alternative to this
* class.
*
* @version 1.0 98/12/15
* @author Steve Polyak 
*/
public class defaultexp {

  public String buildIssue() {

    Object[] message = new Object[3];
    JComboBox cb = new JComboBox();
    cb.addItem("expand");
    cb.addItem("achieve");
    
    message[0] = "Select issue type and enter expression:";
    message[1] = cb;
    message[2] = new JTextField();
    
    String[] options = {"OK","Cancel"};
    
    int result = JOptionPane.showOptionDialog(null, 
					      message, 
					      "Build Default Issue", 
					      JOptionPane.DEFAULT_OPTION, 
					      JOptionPane.QUESTION_MESSAGE,
					      null, options, options[0]);
    if (result == 1) return "";

    return (String) cb.getSelectedItem() + 
      " {" +((JTextField) message[2]).getText()
      + "}";
  }

  public String buildInputConstraint() {

    Object[] message = new Object[7];

    JTextField txtPattern = new JTextField();
    JTextField txtValue = new JTextField();
    JComboBox cbNodes = new JComboBox();
    JComboBox cbEnd = new JComboBox();

    cbNodes.addItem("Start");
    cbNodes.addItem("Finish");
    cbEnd.addItem("begin");
    cbEnd.addItem("end");
    
    message[0] = "Enter pattern:";
    message[1] = txtPattern;
    message[2] = "Enter value:";
    message[3] = txtValue;
    message[4] = "at";
    message[5] = cbNodes;
    message[6] = cbEnd;

    String[] options = {"OK","Cancel"};
    
    int result = JOptionPane.showOptionDialog(null, 
					      message, 
					      "Build Default Input", 
					      JOptionPane.DEFAULT_OPTION, 
					      JOptionPane.QUESTION_MESSAGE,
					      null, options, options[0]);
    if (result == 1) return "";

    return "{" + txtPattern.getText() + "}=" + txtValue.getText() 
      + " at " + (String)
      cbEnd.getSelectedItem() + "-of(" + 
      (String) cbNodes.getSelectedItem() + ")";
  } 

}
